package com.zksy.controller.info;

import cn.hutool.core.date.DateTime;
import com.zksy.info.domain.EEmployeeBenefit;
import com.zksy.info.domain.EEmployeeSalary;
import com.zksy.info.service.EEmployeeBenefitService;
import com.zksy.info.service.EEmployeeSalaryService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 员工福利管理控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/eemployeeBenefit")
@Api(tags = "员工福利管理控制层",description = "员工福利管理控制层desc")
public class EEmployeeBenefitController {
    @Autowired
    private EEmployeeBenefitService service;
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "员工福利管理查询")
    public AjaxResult getById(@PathVariable String id) {
        return AjaxResult.success(service.getById(id));
    }
    @GetMapping("/getList")
    @ApiOperation(value = "员工福利管理查询所有")
    public AjaxResult getList(String employeeNo,String fullName,String benefitStatus) {
        return AjaxResult.success(service.getEEmployeeBenefitList(employeeNo, fullName, benefitStatus));
    }
    @GetMapping("/findByPage")
    @ApiOperation(value = "员工福利管理查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String employeeNo,String fullName,String benefitStatus){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, employeeNo, fullName,benefitStatus));
    }
    @PostMapping("/save")
    @ApiOperation(value = "员工福利管理保存")
    public AjaxResult save(@RequestBody EEmployeeBenefit eemployeeBenefit) {
        return service.save(eemployeeBenefit)? AjaxResult.success(eemployeeBenefit): AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "员工福利管理修改")
    public AjaxResult update(@RequestBody EEmployeeBenefit eemployeeBenefit) {
        eemployeeBenefit.setUpdateTime(LocalDateTime.now());
        return service.updateById(eemployeeBenefit)? AjaxResult.success(eemployeeBenefit): AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "员工福利管理删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids))? AjaxResult.success("删除成功"): AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EEmployeeBenefit.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response, String employeeNo,String fullName,String benefitStatus) {
        ExcelExportUtil.exportExcel(response,service.getEEmployeeBenefitList(employeeNo,fullName,benefitStatus), EEmployeeBenefit.class, "员工福利管理","员工福利管理");
    }
}
